Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints2D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints2D.cs	(revision 9593)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints2D.cs	(revision 9593)
@@ -0,0 +1,114 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.BinPacking.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.BinPacking.Shapes;
+using HeuristicLab.Problems.BinPacking.PackingItem;
+using HeuristicLab.Problems.BinPacking.PackingBin;
+
+namespace HeuristicLab.Problems.BinPacking.Dimensions {
+  [Item("Occupated Points 2D", "A datastructure holding all currently occupied points of a 2D packing-bin.")]
+  [StorableClass]
+  public class OccupiedPoints2D : OccupiedPoints<TwoDimensionalPacking, RectangularPackingItem> {
+                   
+    [Storable]
+    private int[,] occupiedPoints { get; set; }
+
+    public OccupiedPoints2D(RectangularPackingBin binMeasures) : base() {
+      occupiedPoints = new int[binMeasures.Width, binMeasures.Height];
+      for (int w = 0; w < binMeasures.Width; w++) {
+        for (int h = 0; h < binMeasures.Height; h++) {
+          occupiedPoints[w, h] = -1;
+        }
+      }
+    }
+    [StorableConstructor]
+    protected OccupiedPoints2D(bool deserializing) : base(deserializing) { }
+    protected OccupiedPoints2D(OccupiedPoints2D original, Cloner cloner)
+      : base(original, cloner) {
+      this.occupiedPoints = (int[,])original.occupiedPoints.Clone();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OccupiedPoints2D(this, cloner);
+    }
+
+    public override bool IsPositionFeasible(RectangularPackingItem measures, TwoDimensionalPacking position) {
+      for (int w = position.X; w < position.X + measures.Width; w++) {
+        for (int h = position.Y; h < position.Y + measures.Height; h++) {
+          if (occupiedPoints[w, h] != -1)
+            return false;
+        }
+      }
+      return true;
+    }
+
+    public override void OccupyPoints(RectangularPackingItem measures, TwoDimensionalPacking position, int itemID) {
+      int width = position.Rotated ? measures.Height : measures.Width;
+      int height = position.Rotated ? measures.Width : measures.Height;
+      for (int w = position.X; w < position.X + width; w++) {
+        for (int h = position.Y; h < position.Y + height; h++) {
+          occupiedPoints[w, h] = itemID;
+        }
+      }
+    }
+
+    public override bool IsPointOccupied(TwoDimensionalPacking point) {
+      return occupiedPoints[point.X, point.Y] != -1;
+    }
+
+    public override int ShortestPossibleSideFromEP(TwoDimensionalPacking ep) {
+      int shortestSide = int.MaxValue;
+      int width = occupiedPoints.GetLength(0);
+      int height = occupiedPoints.GetLength(1);
+
+      if (ep.X >= width || ep.Y >= height)
+        return shortestSide;
+
+      int currentX = ep.X;
+      while (currentX < width && occupiedPoints[currentX, ep.Y] == -1) { currentX++; }
+      if (currentX - ep.X < shortestSide)
+        shortestSide = currentX - ep.X;
+
+      int currentY = ep.Y;
+      while (currentY < height && occupiedPoints[ep.X, currentY] == -1) { currentY++; }
+      if (currentY - ep.Y < shortestSide)
+        shortestSide = currentY - ep.Y;
+
+      return shortestSide;
+    }
+
+    public override bool IsStaticStable(RectangularPackingItem item, TwoDimensionalPacking ep) {
+      //For the current implementation there was no need for stacking-constraints in the 2D-case. 
+      //But it could be interesting for shelf-packing applications!
+      return true;
+    }
+    public override bool WeightIsSupported(RectangularPackingItem item, TwoDimensionalPacking ep, ItemList<RectangularPackingItem> items) {
+      return true;
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints3D.cs	(revision 9593)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints3D.cs	(revision 9593)
@@ -0,0 +1,168 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.BinPacking.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.BinPacking.Shapes;
+using HeuristicLab.Problems.BinPacking.PackingItem;
+using HeuristicLab.Problems.BinPacking.PackingBin;
+
+namespace HeuristicLab.Problems.BinPacking.Dimensions {
+  [Item("Occupied Points 3D", "A datastructure holding all currently occupied points of a 3D packing-bin.")]
+  [StorableClass]
+  public class OccupiedPoints3D : OccupiedPoints<ThreeDimensionalPacking, CuboidPackingItem> {
+
+    [Storable]
+    private int[, ,] occupiedPoints { get; set; }
+
+    public OccupiedPoints3D(CuboidPackingBin binMeasures) {
+      occupiedPoints = new int[binMeasures.Width, binMeasures.Height, binMeasures.Depth];
+      for (int w = 0; w < binMeasures.Width; w++) {
+        for (int h = 0; h < binMeasures.Height; h++) {
+          for (int d = 0; d < binMeasures.Depth; d++) {
+            occupiedPoints[w, h, d] = -1;
+          }
+        }
+      }
+    }
+    [StorableConstructor]
+    protected OccupiedPoints3D(bool deserializing) : base(deserializing) { }
+    protected OccupiedPoints3D(OccupiedPoints3D original, Cloner cloner)
+      : base(original, cloner) {
+        this.occupiedPoints = (int[,,])original.occupiedPoints.Clone();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OccupiedPoints3D(this, cloner);
+    }
+
+    public override bool IsPositionFeasible(CuboidPackingItem measures, ThreeDimensionalPacking position) {
+      for (int w = position.X; w < position.X + measures.Width; w++) {
+        for (int h = position.Y; h < position.Y + measures.Height; h++) {
+          for (int d = position.Z; d < position.Z + measures.Depth; d++) {
+            if (occupiedPoints[w, h, d] != -1)
+              return false;
+          }
+        }
+      }
+      return true;
+    }
+
+    public override void OccupyPoints(CuboidPackingItem measures, ThreeDimensionalPacking position, int itemID) {
+      int width = position.Rotated ? measures.Depth : measures.Width;
+      int depth = position.Rotated ? measures.Width : measures.Depth;
+      for (int w = position.X; w < position.X + width; w++) {
+        for (int h = position.Y; h < position.Y + measures.Height; h++) {
+          for (int d = position.Z; d < position.Z + depth; d++) {
+            occupiedPoints[w, h, d] = itemID;
+          }
+        }
+      }
+    }
+
+    public override bool IsPointOccupied(ThreeDimensionalPacking point) {
+      return occupiedPoints[point.X, point.Y, point.Z] != -1;
+    }
+
+    public override int ShortestPossibleSideFromEP(ThreeDimensionalPacking ep) {
+      int shortestSide = int.MaxValue;
+      int width = occupiedPoints.GetLength(0);
+      int height = occupiedPoints.GetLength(1);
+      int depth = occupiedPoints.GetLength(2);
+
+      if (ep.X >= width || ep.Y >= height || ep.Z >= depth)
+        return shortestSide;
+
+      int currentX = ep.X;
+      while (currentX < width && occupiedPoints[currentX, ep.Y, ep.Z] == -1) { currentX++; }
+      if (currentX - ep.X < shortestSide)
+        shortestSide = currentX - ep.X;
+
+      int currentY = ep.Y;
+      while (currentY < height && occupiedPoints[ep.X, currentY, ep.Z] == -1) { currentY++; }
+      if (currentY - ep.Y < shortestSide)
+        shortestSide = currentY - ep.Y;
+
+      int currentZ = ep.Z;
+      while (currentZ < depth && occupiedPoints[ep.X, ep.Y, currentZ] == -1) { currentZ++; }
+      if (currentZ - ep.Z < shortestSide)
+        shortestSide = currentZ - ep.Z;
+
+      return shortestSide;
+    }
+
+
+    public override bool IsStaticStable(CuboidPackingItem item, ThreeDimensionalPacking ep) {
+      //Static stability is given, if item is placed on the ground
+      if (ep.Y == 0)
+        return true;
+
+      if (occupiedPoints[ep.X, ep.Y - 1, ep.Z] != -1
+        && occupiedPoints[ep.X + item.Width - 1, ep.Y - 1, ep.Z] != -1
+        && occupiedPoints[ep.X, ep.Y - 1, ep.Z + item.Depth - 1] != -1
+        && occupiedPoints[ep.X + item.Width - 1, ep.Y - 1, ep.Z + item.Depth - 1] != -1)
+        return true;
+
+      //int groundCount = 0;
+      //for (int x = ep.X; x < ep.X + item.Width - 1; x++) {
+      //  for (int z = ep.Z; z < ep.Z + item.Depth - 1; z++) {
+      //    if (occupiedPoints[x,ep.Y-1, z] != -1)                                                     
+      //      groundCount++;
+      //  }
+      //}
+      //double stableGround = (double)(groundCount) / (double)(item.Width * item.Depth);
+      //if (stableGround > 0.75)
+      //  return true;
+
+      return false;
+    }
+    public override bool WeightIsSupported(CuboidPackingItem item, ThreeDimensionalPacking ep, ItemList<CuboidPackingItem> items) {
+      //Static stability is given, if item is placed on the ground
+      if (ep.Y == 0)
+        return true;
+
+      if (items[occupiedPoints[ep.X, ep.Y - 1, ep.Z]].SupportsStacking(item)
+        && items[occupiedPoints[ep.X + item.Width - 1, ep.Y - 1, ep.Z]].SupportsStacking(item)
+        && items[occupiedPoints[ep.X, ep.Y - 1, ep.Z + item.Depth - 1]].SupportsStacking(item)
+        && items[occupiedPoints[ep.X + item.Width - 1, ep.Y - 1, ep.Z + item.Depth - 1]].SupportsStacking(item))
+        return true;
+
+      //int groundCount = 0;
+      //for (int x = ep.X; x < ep.X + item.Width - 1; x++) {
+      //  for (int z = ep.Z; z < ep.Z + item.Depth - 1; z++) {
+      //    if (occupiedPoints[x,ep.Y-1, z] != -1)                                                     
+      //      groundCount++;
+      //  }
+      //}
+      //double stableGround = (double)(groundCount) / (double)(item.Width * item.Depth);
+      //if (stableGround > 0.75)
+      //  return true;
+
+      return false;
+    }
+  
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/Triple/Moves/MCVTripleMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/Triple/Moves/MCVTripleMove.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/Triple/Moves/MCVTripleMove.cs	(revision 9593)
@@ -102,5 +102,5 @@
             return true;
         } else {
-          if ((Index == actualAttribute.Index && TargetIndex == actualAttribute.TargetIndex)
+          if ((Index == actualAttribute.Index || TargetIndex == actualAttribute.TargetIndex)
                   && MultiComponentVector.PackingInformations[OldGroup][Index].ItemID == actualAttribute.ItemID
                   //&& Rotation == actualAttribute.Rotation
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorRandomCreator.cs	(revision 9593)
@@ -70,7 +70,7 @@
 			var solution = new MultiComponentVectorEncoding();
 			if (sortedSequence)
-				solution.PackingInformations = PackingInformation.CreateDictionaryRandomlyWithSortedSequence(items, lowerBound, random);
+				solution.PackingInformations = PackingInformation.CreateDictionaryRandomlyWithSortedSequence(items, /*lowerBound*/ 1, random);
 			else
-				solution.PackingInformations = PackingInformation.CreateDictionaryRandomly(items, lowerBound, random);
+        solution.PackingInformations = PackingInformation.CreateDictionaryRandomly(items, /*lowerBound*/ 1, random);
 			return solution;
 		}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/SequenceBasedMultiComponentVectorCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/SequenceBasedMultiComponentVectorCrossover.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/SequenceBasedMultiComponentVectorCrossover.cs	(revision 9593)
@@ -44,5 +44,31 @@
     public override MultiComponentVectorEncoding Cross(IRandom random, MultiComponentVectorEncoding parent1, MultiComponentVectorEncoding parent2) {
       MultiComponentVectorEncoding child = new MultiComponentVectorEncoding ();
-      
+
+      int nrOfItems = parent1.NrOfItems;
+      bool[] itemAlreadyAssigned = new bool[nrOfItems];
+      int nrOfBins = parent1.NrOfBins > parent2.NrOfBins ? parent2.NrOfBins : parent1.NrOfBins;
+      int swappedBin = random.Next(nrOfBins);
+
+      for (int binNr = 0; binNr < nrOfBins; binNr++) {
+
+        var newBin = new ItemList<PackingInformation>();
+        var currentParent = binNr == swappedBin ? parent1 : parent2;
+
+        int nrOfItemsInBin = currentParent.PackingInformations[binNr].Count;
+        for (int i = 0; i < nrOfItemsInBin; i++) {
+          PackingInformation pi = new PackingInformation(currentParent.PackingInformations[binNr][i]);
+          if (!itemAlreadyAssigned[pi.ItemID]) {
+            itemAlreadyAssigned[pi.ItemID] = true;
+            newBin.Add(new PackingInformation(pi));
+          }
+        }
+
+        child.PackingInformations[binNr] = newBin;
+      }
+
+      for (int itemID = 0; itemID < nrOfItems; itemID++) {
+        if (!itemAlreadyAssigned[itemID])
+          child.PackingInformations[0].Add(new PackingInformation(itemID, random.Next(2) == 0 ? true : false));
+      }
 
 
